3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] [-CNUM] <mbox>...
7 or, when resuming [--skip | --resolved]'
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
15 echo "$1" >"$dotest/next"
19 stop_here_user_resolve () {
20 if [ -n "$resolvemsg" ]; then
24 cmdline=$(basename $0)
25 if test '' != "$interactive"
29 if test '' != "$threeway"
33 if test '.dotest' != "$dotest"
35 cmdline="$cmdline -d=$dotest"
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
52 echo "Cannot fall back to three-way merge."
57 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
59 rm -fr "$dotest"/patch-merge-*
60 mkdir "$dotest/patch-merge-tmp-dir"
62 # First see if the patch records the index info that we can use.
63 git-apply -z --index-info "$dotest/patch" \
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git-write-tree >"$dotest/patch-merge-base+" ||
69 cannot_fallback "Patch does not record usable index information."
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73 git-apply $binary --cached <"$dotest/patch"
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
78 cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
82 test -f "$dotest/patch-merge-index" &&
83 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
84 orig_tree=$(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-* || exit 1
87 echo Falling back to patching base and 3-way merge...
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
95 eval GITHEAD_$his_tree='"$SUBJECT"'
96 export GITHEAD_$his_tree
97 git-merge-recursive $orig_tree -- HEAD $his_tree || {
98 if test -d "$GIT_DIR/rr-cache"
102 echo Failed to merge in the changes.
105 unset GITHEAD_$his_tree
109 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary= resolvemsg=
112 while case "$#" in 0) break;; esac
115 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
116 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
117 -d|--d|--do|--dot|--dote|--dotes|--dotest)
118 case "$#" in 1) usage ;; esac; shift
121 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
122 --interacti|--interactiv|--interactive)
123 interactive=t; shift ;;
125 -b|--b|--bi|--bin|--bina|--binar|--binary)
128 -3|--3|--3w|--3wa|--3way)
130 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
132 -u|--u|--ut|--utf|--utf8)
133 utf8=t; shift ;; # this is now default
134 --no-u|--no-ut|--no-utf|--no-utf8)
136 -k|--k|--ke|--kee|--keep)
139 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
146 git_apply_opt="$git_apply_opt $1"; shift ;;
149 git_apply_opt="$git_apply_opt $1"; shift ;;
152 resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
163 # If the dotest directory exists, but we have finished applying all the
164 # patches in them, clear it out.
165 if test -d "$dotest" &&
166 last=$(cat "$dotest/last") &&
167 next=$(cat "$dotest/next") &&
169 test "$next" -gt "$last"
176 case "$#,$skip$resolved" in
178 # Explicit resume command and we do not have file, so
182 # No file input but without resume parameters; catch
183 # user error to feed us a patch from standard input
184 # when there is already .dotest. This is somewhat
185 # unreliable -- stdin could be /dev/null for example
186 # and the caller did not intend to feed us a patch but
187 # wanted to continue unattended.
194 die "previous dotest directory $dotest still exists but mbox given."
197 # Make sure we are not given --skip nor --resolved
198 test ",$skip,$resolved," = ,,, ||
199 die "Resolve operation not in progress, we are not resuming."
202 mkdir -p "$dotest" || exit
204 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
209 # -b, -s, -u, -k and --whitespace flags are kept for the
210 # resuming session after a patch failure.
211 # -3 and -i can and must be given when resuming.
212 echo "$binary" >"$dotest/binary"
213 echo " $ws" >"$dotest/whitespace"
214 echo "$sign" >"$dotest/sign"
215 echo "$utf8" >"$dotest/utf8"
216 echo "$keep" >"$dotest/keep"
217 echo 1 >"$dotest/next"
222 files=$(git-diff-index --cached --name-only HEAD) || exit
223 if [ "$files" ]; then
224 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
229 if test "$(cat "$dotest/binary")" = t
231 binary=--allow-binary-replacement
233 if test "$(cat "$dotest/utf8")" = t
239 if test "$(cat "$dotest/keep")" = t
243 ws=`cat "$dotest/whitespace"`
244 if test "$(cat "$dotest/sign")" = t
246 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
248 s/^/Signed-off-by: /'
254 last=`cat "$dotest/last"`
255 this=`cat "$dotest/next"`
258 if test -d "$GIT_DIR/rr-cache"
262 this=`expr "$this" + 1`
266 if test "$this" -gt "$last"
273 while test "$this" -le "$last"
275 msgnum=`printf "%0${prec}d" $this`
276 next=`expr "$this" + 1`
277 test -f "$dotest/$msgnum" || {
283 # If we are not resuming, parse and extract the patch information
284 # into separate files:
285 # - info records the authorship and title
286 # - msg is the rest of commit log message
287 # - patch is the patch body.
289 # When we are resuming, these files are either already prepared
290 # by the user, or the user can tell us to do so by --resolved flag.
293 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
294 <"$dotest/$msgnum" >"$dotest/info" ||
296 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
300 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
301 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
302 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
304 if test -z "$GIT_AUTHOR_EMAIL"
306 echo "Patch does not have a valid e-mail address."
310 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
312 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
313 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
317 if test '' != "$SIGNOFF"
320 sed -ne '/^Signed-off-by: /p' \
321 "$dotest/msg-clean" |
325 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
326 test '' = "$LAST_SIGNED_OFF_BY" && echo
334 if test -s "$dotest/msg-clean"
337 cat "$dotest/msg-clean"
339 if test '' != "$ADD_SIGNOFF"
343 } >"$dotest/final-commit"
346 case "$resolved$interactive" in
348 # This is used only for interactive view option.
349 git-diff-index -p --cached HEAD >"$dotest/patch"
355 if test "$interactive" = t
358 die "cannot be interactive without stdin connected to a terminal."
360 while test "$action" = again
362 echo "Commit Body is:"
363 echo "--------------------------"
364 cat "$dotest/final-commit"
365 echo "--------------------------"
366 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
370 [aA]*) action=yes interactive= ;;
371 [nN]*) action=skip ;;
372 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
375 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
383 if test $action = skip
389 if test -x "$GIT_DIR"/hooks/applypatch-msg
391 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
396 echo "Applying '$SUBJECT'"
401 git-apply $git_apply_opt $binary --index "$dotest/patch"
405 # Resolved means the user did all the hard work, and
406 # we do not have to do any patch application. Just
407 # trust what the user has in the index file and the
410 changed="$(git-diff-index --cached --name-only HEAD)"
411 if test '' = "$changed"
413 echo "No changes - did you forget to use 'git add'?"
414 stop_here_user_resolve $this
416 unmerged=$(git-ls-files -u)
417 if test -n "$unmerged"
419 echo "You still have unmerged paths in your index"
420 echo "did you forget to use 'git add'?"
421 stop_here_user_resolve $this
424 if test -d "$GIT_DIR/rr-cache"
431 if test $apply_status = 1 && test "$threeway" = t
435 # Applying the patch to an earlier tree and merging the
436 # result may have produced the same tree as ours.
437 changed="$(git-diff-index --cached --name-only HEAD)"
438 if test '' = "$changed"
440 echo No changes -- Patch already applied.
444 # clear apply_status -- we have successfully merged.
448 if test $apply_status != 0
450 echo Patch failed at $msgnum.
451 stop_here_user_resolve $this
454 if test -x "$GIT_DIR"/hooks/pre-applypatch
456 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
459 tree=$(git-write-tree) &&
460 echo Wrote tree $tree &&
461 parent=$(git-rev-parse --verify HEAD) &&
462 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
463 echo Committed: $commit &&
464 git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
467 if test -x "$GIT_DIR"/hooks/post-applypatch
469 "$GIT_DIR"/hooks/post-applypatch